



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用zlib库进行目录打包</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用zlib库进行目录打包</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 17:06:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>代码很简单，具体过程就不写了。<br /><br />
关于加密压缩，可以看<a href="http://www.zlib.net/zlib_faq.html#faq38" rel="external nofollow noreferrer">http://www.zlib.net/zlib_faq.html#faq38</a> 中的描述，说是不支持的，但是创建的时候可以传入密码进去，不过我还没有搞清楚这个密码要如何设置。</p>
<p>压缩算法模式参数:<br /><br />
0 - 存储文件 (无压缩)<br /><br />
8 - 文件使用Deflated算法压缩<br /><br />
9 - 使用Deflate64(tm)压缩<br /><br />
10 - PKWARE数据压缩库<br /><br />
12 - 文件使用BZIP2算法压缩</p>
<pre class="prettyprint linenums"><code>#include &quot;zlib.h&quot;<br />
#include &quot;zip.h&quot;<br />
#ifdef _WIN32<br />
#define USEWIN32IOAPI<br />
#include &quot;iowin32.h&quot;<br />
#endif

#include &lt;QFile&gt;<br />
#include &lt;QDir&gt;<br />
#include &lt;QDateTime&gt;

/*转换Qstring到utf8字符串*/<br />
inline std::string ToUtf8(const QString&amp; str)<br />
{<br />
    QByteArray u8 = str.toUtf8();<br />
    return std::string(u8.data(),u8.size());<br />
}

QStringList FileListR(const QDir&amp; dir)<br />
{<br />
    QFileInfoList fileinfolist = dir.entryInfoList(<br />
                QDir::NoDotAndDotDot|QDir::Files|QDir::Dirs);<br />
    QStringList files;<br />
    for(int i=0;i&lt;fileinfolist.size();++i){<br />
        QFileInfo&amp; info = fileinfolist[i];<br />
        if(info.isDir()){<br />
            files.append(FileListR(QDir(info.filePath())));<br />
            continue;<br />
        }<br />
        files.append(info.filePath());<br />
    }<br />
    return files;<br />
}

// zlib打包压缩测试<br />
void zlib_archive_compress(QString path,QString outpath)<br />
{<br />
    QDir dir(path);<br />
    QStringList entrylist = FileListR(dir);

    int err = 0;<br />
    zipFile zipfile;

#ifdef _WIN32<br />
    zlib_filefunc64_def ffunc64;<br />
    fill_win32_filefunc64W(&amp;ffunc64);<br />
    std::wstring wpath = outpath.toStdWString();

    // APPEND_STATUS_CREATE              不存在就创建，存在就截断(清空)<br />
    // APPEND_STATUS_ADDINZIP            不存在打开失败，存在就追加(原本压缩包中的内容不清空)<br />
    // APPEND_STATUS_CREATEAFTER  不存在打开失败,存在就截断(清空)<br />
    zipfile = zipOpen2_64(wpath.c_str(),APPEND_STATUS_CREATE,NULL,&amp;ffunc64);<br />
#else<br />
    zipfile = zipOpen64(ToUtf8(path).c_str(),APPEND_STATUS_CREATE);<br />
#endif<br />
    if(zipfile == NULL){<br />
        qDebug()&lt;&lt;&quot;zipOpen64 error &quot; &lt;&lt; ZIP_ERRNO;<br />
        return;<br />
    }

    // 逐个文件添加<br />
    for(int i=0;i&lt;entrylist.size();++i){<br />
        QFileInfo info(entrylist[i]);<br />
        QDateTime ctime = info.created();    // 获取文件创建时间<br />
        zip_fileinfo zipinfo;<br />
        zipinfo.tmz_date.tm_year = ctime.date().year();<br />
        zipinfo.tmz_date.tm_mon = ctime.date().month();<br />
        zipinfo.tmz_date.tm_mday = ctime.date().day();<br />
        zipinfo.tmz_date.tm_hour = ctime.time().hour();<br />
        zipinfo.tmz_date.tm_min = ctime.time().minute();<br />
        zipinfo.tmz_date.tm_sec = ctime.time().second();<br />
        zipinfo.dosDate = 0;<br />
        zipinfo.external_fa = zipinfo.internal_fa = 0;

        // 在zip包中打开一个新文件<br />
        err = zipOpenNewFileInZip3_64(<br />
                    zipfile,<br />
                    ToUtf8(info.filePath().remove(dir.path())).c_str(),/*在zip文件中的文件路径(我这里使用UTF8，可以根据需求自己抉择，文件名可以重复)*/<br />
                    &amp;zipinfo,<br />
                    NULL,0,NULL,0,NULL,<br />
                    Z_DEFLATED,Z_DEFAULT_COMPRESSION, /*压缩参数(默认参数)*/<br />
                    0,-MAX_WBITS,DEF_MEM_LEVEL,Z_DEFAULT_STRATEGY,<br />
                    NULL /*加密参数(不加密)*/ ,0 /*crc校验值*/,0 /*是否为zip64*/<br />
                    );<br />
       // 在zip包中添加新文件失败<br />
        if(err != ZIP_OK){<br />
            qDebug()&lt;&lt;QString::fromAscii(&quot;zipOpenNewFileInZip3_64 failed  &quot;)&lt;&lt;err;<br />
            zipCloseFileInZip(zipfile);<br />
           break;<br />
        }<br />
        QFile file(info.filePath());<br />
        if(!file.open(QIODevice::ReadOnly)){<br />
            qDebug()&lt;&lt;QString::fromAscii(&quot;OpenFile failed  &quot;)&lt;&lt;file.fileName();<br />
            zipCloseFileInZip(zipfile);<br />
            continue;<br />
        }<br />
        // 读取文件内容，写入zip包文件<br />
        qint64 filesize = file.size();<br />
        for(qint64 rbeg = 0;rbeg&lt;filesize;rbeg+=(4&lt;&lt;20)){<br />
            QByteArray buffer = file.read(4&lt;&lt;20);<br />
            err = zipWriteInFileInZip(zipfile,buffer.data(),buffer.size());<br />
            if(err &lt; 0){<br />
                qDebug()&lt;&lt;&quot;error : &quot;&lt;&lt;err;<br />
                break;<br />
            }<br />
        }<br />
        zipCloseFileInZip(zipfile);<br />
    }

    err = zipClose(zipfile,NULL);<br />
    if(err &lt; 0){<br />
        qDebug()&lt;&lt;&quot;error : &quot;&lt;&lt;err;<br />
    }<br />
}

int main(int argc, char *argv[])<br />
{<br />
    QTime time;<br />
    time.start();<br />
    zlib_archive_compress(<br />
                QString::fromLocal8Bit(&quot;Z:/Everything-SDK/src&quot;),<br />
                QString::fromLocal8Bit(&quot;Z:/Everything-SDK/srctest.zip&quot;));<br />
    int t = time.elapsed();<br />
    qDebug()&lt;&lt;t&lt;&lt;&quot; ms&quot;;<br />
    return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jgppl9.html">SSM框架搭建（转发）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7lwk9.html">django 添加comments app</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q75r3k9.html">C&plus;&plus;二级指针第三种内存模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok4yd59.html">tomcat servlet 线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ppy4q.html">【转】Eclipse中一键调用javah生成jni的头文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4rvrq.html">MySQL 5&period;6初始配置调整</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn4gk9.html">BZOJ 1901&colon; Zju2112 Dynamic Rankings&lpar; BIT 套 BST &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkw038.html">Java 实现下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med3j2q.html">用TcpClient如何获取远程网页的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mey248.html">wemall app商城源码Android数据的SharedPreferences储存方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj270pq.html">windows 异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4p7w8.html">BZOJ&lowbar;1717&lowbar;&lbrack;Usaco2006 Dec&rsqb;Milk Patterns 产奶的模式&lowbar;后缀数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gelr0e8.html">Windows启动过程&lpar;MBR引导过程分析&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd2yz9.html">第十六节：语法总结&lpar;3&rpar;&lpar;C&num;6&period;0和C&num;7&period;0新语法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960g17y9.html">HNOI2018题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw3lg09.html">ROS 时间同步问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16vm09.html">使用HttpClient实现并发请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wzyerq.html">Linux学习 ：移植linux-3&period;4&period;83到JZ2440开发板</a>
		</li>
						<li><a href="https://www.batexi.com/a/95goyxeq.html">CodeForces - 1101G &colon;&lpar;Zero XOR Subset&rpar;-less&lpar;线性基&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvp3og8.html">Django从MySQL数据库生成model</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wl51gq.html">基于bootstrap的基本模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wrxxzq.html">python&lowbar;cookbook之路：数据结构-解压可迭代对象赋值给多个变量以及扩展的迭代解压语法（&ast;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj6mj79.html">NDK 开发实例一（Android&period;mk环境配置下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv61k38.html">Storm通信机制（了解）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e46y1z9.html">HDU4857 逃生   拓扑排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ovzwe8.html">001 Python中的基本类型初步介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2p2jy9.html">SQL基本练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25exzwq.html">UTF8编码的Base64解密 MSSQL实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9602mxn9.html">网页图表Highcharts实践教程之认识Highcharts</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j5nzjq.html">洛谷P3373 &lbrack;模板&rsqb;线段树 2&lpar;区间增减&period;乘 区间求和&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
